package kakapo.crypto.bouncy;

import name.neuhalfen.projects.crypto.bouncycastle.openpgp.BouncyGPG;
import name.neuhalfen.projects.crypto.bouncycastle.openpgp.BuildDecryptionInputStreamAPI;
import name.neuhalfen.projects.crypto.bouncycastle.openpgp.BuildEncryptionOutputStreamAPI;
import name.neuhalfen.projects.crypto.bouncycastle.openpgp.keys.generation.KeyRingBuilder;
import name.neuhalfen.projects.crypto.bouncycastle.openpgp.keys.generation.SimpleKeyRingBuilder;

public final class SigningBouncyGPG {

    private SigningBouncyGPG() {
        // Prevents unwanted instantiation.
    }

    public static BuildSigningOutputStreamAPI signToStream() {
        return new BuildSigningOutputStreamAPI();
    }

    public static BuildVerificationInputStreamAPI verifyStream() {
        return new BuildVerificationInputStreamAPI();
    }

    public static BuildEncryptionOutputStreamAPI encryptToStream() {
        return BouncyGPG.encryptToStream();
    }

    public static BuildDecryptionInputStreamAPI decryptAndVerifyStream() {
        return BouncyGPG.decryptAndVerifyStream();
    }

    public static KeyRingBuilder createKeyring() {
        return BouncyGPG.createKeyring();
    }

    public static SimpleKeyRingBuilder createSimpleKeyring() {
        return BouncyGPG.createSimpleKeyring();
    }

    public synchronized static void registerProvider() {
        BouncyGPG.registerProvider();
    }

}
